Subject: Re: bug#20749: 11.88; Meta Bug: Long standing preview bug with TIKZ (6 years!?)

From: Tassilo Horn <[email-masked]>
Date: Mon, 08 Jun 2015 20:10:52 +0200

Nicolas Richard <[email-masked]> writes:

Hi Nicolas,

>> Why do you think that?  AFAICS, no official has done a statement on
>> that, and the issue is just one year old.
>
> Err... yeah maybe I'm being pessimistic again.

Hehe, but yes, one year without official comment sounds like at least
nobody is especially interested in the issue.

>>> FWIW I've been running with that patch for a few months have yet to
>>> see a problem with it.
>>
>> Which one?
>
> The "correct patch". More precisely, it's :
>
> --- /tmp/pgfutil-latex-ctan.def	2015-06-08 19:36:06.890121795 +0200
> +++ /usr/local/texlive/2014/texmf-dist/tex/generic/pgf/utilities/pgfutil-latex.def	2015-06-08 19:39:09.686116394 +0200
> @@ -134,16 +134,17 @@
>  % material to get lost.
>  
>  \AtBeginDocument{
> -  \@ifpackageloaded{preview}{%
> -    % Ok, package loaded. Swap definitions of everyshi.sty's shipout
> -    % and preview.sty's shipout:
> -    \let\pgf@temp\pr@shipout% This is the original shipout
> -    \let\pr@shipout\@EveryShipout@Shipout% This is what preview.sty should call
> -    \let\@EveryShipout@Org@Shipout\pgf@temp% Everyshi should now use the original one
> -  }{}%    
> +\@ifpackageloaded{preview}{%
> +% Ok, package loaded. Swap definitions of everyshi.sty's shipout
> +% and preview.sty's shipout:
> +\ifPreview
> +\let\shipout\@EveryShipout@Org@Shipout%This is the null version of \shipout, created by preview and saved by everyshi
> +\let\@EveryShipout@Org@Shipout\pr@shipout% This is the original shipout
> +\let\pr@shipout\@EveryShipout@Shipout%
> +\fi
> +}{}%
>  }

Hey, cool.  I patched my
/usr/local/texlive/2014/texmf-dist/tex/generic/pgf/utilities/pgfutil-latex.def
with this corrected version, and now previews work at least in the
minimal test file I've used to reproduce the issue.

>>             And do you also save \shipout before \begin{document} and
>> restore it afterwards as indicated by the comment by Kirill Müller?
>
> I don't.

Me neither and still seems to work.

>> In any case: if there's anything that we could put into preview.dtx
>> to fix the issue from our side, that would be awesome.  Patch
>> welcome!
>
> I admit I haven't looked into it, but I'm afraid I won't be able to
> help.

Ok, no problem.

Bye,
Tassilo